Unit AFG3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFG3C(var A :Array of Complex; var B :Array of Complex;
                var Z :Array of Complex; N :Integer; M :Integer);

implementation

procedure AFG3C(var A :Array of Complex; var B :Array of Complex;
                var Z :Array of Complex; N :Integer; M :Integer);
var
NM1,IP1,K,II,J,NM2,JM2,JP1,IM1,IMJ,I :Integer;
C,D :Real;
Y,W,X :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27;
begin
NM1 := N-1;
for I:=1 to NM1 do
 begin
  D := 0.0;
  IP1 := I+1;
  for K:=IP1 to N do
   begin
    Y := B[(K-1)+(I-1)*N];
    C := Abs(Creal(Y))+Abs(Aimag(Y));
    if ( C <= D ) 
     then goto _1;
    D := C;
    II := K;
_1:
   end;
  if ( D = 0.0 ) 
   then goto _8;
  Y := B[(I-1)+(I-1)*N];
  if ( D <= Abs(Creal(Y))+Abs(Aimag(Y)) ) 
   then goto _4;
  for J:=1 to N do
   begin
    Y := A[(I-1)+(J-1)*N];
    A[(I-1)+(J-1)*N] := A[(II-1)+(J-1)*N];
    A[(II-1)+(J-1)*N] := Y;
_2:
   end;
  for J:=I to N do
   begin
    Y := B[(I-1)+(J-1)*N];
    B[(I-1)+(J-1)*N] := B[(II-1)+(J-1)*N];
    B[(II-1)+(J-1)*N] := Y;
_3:
   end;
_4:
  for J:=IP1 to N do
   begin
    Y := DivC(B[(J-1)+(I-1)*N],B[(I-1)+(I-1)*N]);
    if ( Creal(Y) = 0.0 ) and ( Aimag(Y) = 0.0 ) 
     then goto _7;
    for K:=1 to N do
     begin
      A[(J-1)+(K-1)*N] := SubC(A[(J-1)+(K-1)*N],MulC(Y,A[(I-1)+(K-1)*N]));
_5:
     end;
    for K:=IP1 to N do
     begin
      B[(J-1)+(K-1)*N] := SubC(B[(J-1)+(K-1)*N],MulC(Y,B[(I-1)+(K-1)*N]));
_6:
     end;
_7:
   end;
  B[(IP1-1)+(I-1)*N] := Cmplx(0.0,0.0);
_8:
 end;
if ( M = 1 ) 
 then goto _11;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    Z[(I-1)+(J-1)*N] := Cmplx(0.0,0.0);
_9:
   end;
  Z[(I-1)+(I-1)*N] := Cmplx(1.0,0.0);
_10:
 end;
_11:
NM2 := N-2;
if ( NM2 < 1 ) 
 then goto _27;
for J:=1 to NM2 do
 begin
  JM2 := NM1-J;
  JP1 := J+1;
  for II:=1 to JM2 do
   begin
    I := N+1-II;
    IM1 := I-1;
    IMJ := I-J;
    W := A[(I-1)+(J-1)*N];
    X := A[(IM1-1)+(J-1)*N];
    if ( Abs(Creal(W))+Abs(Aimag(W)) <= Abs(Creal(X))+
         Abs(Aimag(X)) ) 
     then goto _14;
    for K:=J to N do
     begin
      Y := A[(I-1)+(K-1)*N];
      A[(I-1)+(K-1)*N] := A[(IM1-1)+(K-1)*N];
      A[(IM1-1)+(K-1)*N] := Y;
_12:
     end;
    for K:=IM1 to N do
     begin
      Y := B[(I-1)+(K-1)*N];
      B[(I-1)+(K-1)*N] := B[(IM1-1)+(K-1)*N];
      B[(IM1-1)+(K-1)*N] := Y;
_13:
     end;
_14:
    X := A[(I-1)+(J-1)*N];
    if ( Creal(X) = 0.0 ) and ( Aimag(X) = 0.0 ) 
     then goto _17;
    Y := DivC(X,A[(IM1-1)+(J-1)*N]);
    for K:=JP1 to N do
     begin
      A[(I-1)+(K-1)*N] := SubC(A[(I-1)+(K-1)*N],MulC(Y,A[(IM1-1)+(K-1)*N]));
_15:
     end;
    for K:=IM1 to N do
     begin
      B[(I-1)+(K-1)*N] := SubC(B[(I-1)+(K-1)*N],MulC(Y,B[(IM1-1)+(K-1)*N]));
_16:
     end;
_17:
    W := B[(I-1)+(IM1-1)*N];
    X := B[(I-1)+(I-1)*N];
    if ( Abs(Creal(W))+Abs(Aimag(W)) <= Abs(Creal(X))+
         Abs(Aimag(X)) ) 
     then goto _21;
    for K:=1 to I do
     begin
      Y := B[(K-1)+(I-1)*N];
      B[(K-1)+(I-1)*N] := B[(K-1)+(IM1-1)*N];
      B[(K-1)+(IM1-1)*N] := Y;
_18:
     end;
    for K:=1 to N do
     begin
      Y := A[(K-1)+(I-1)*N];
      A[(K-1)+(I-1)*N] := A[(K-1)+(IM1-1)*N];
      A[(K-1)+(IM1-1)*N] := Y;
_19:
     end;
    if ( M = 1 ) 
     then goto _21;
    for K:=IMJ to N do
     begin
      Y := Z[(K-1)+(I-1)*N];
      Z[(K-1)+(I-1)*N] := Z[(K-1)+(IM1-1)*N];
      Z[(K-1)+(IM1-1)*N] := Y;
_20:
     end;
_21:
    X := B[(I-1)+(IM1-1)*N];
    if ( Creal(X) = 0.0 ) and ( Aimag(X) = 0.0 ) 
     then goto _25;
    Y := DivC(X,B[(I-1)+(I-1)*N]);
    for K:=1 to IM1 do
     begin
      B[(K-1)+(IM1-1)*N] := SubC(B[(K-1)+(IM1-1)*N],MulC(Y,B[(K-1)+(I-1)*N]));
_22:
     end;
    B[(I-1)+(IM1-1)*N] := Cmplx(0.0,0.0);
    for K:=1 to N do
     begin
      A[(K-1)+(IM1-1)*N] := SubC(A[(K-1)+(IM1-1)*N],MulC(Y,A[(K-1)+(I-1)*N]));
_23:
     end;
    if ( M = 1 ) 
     then goto _25;
    for K:=IMJ to N do
     begin
      Z[(K-1)+(IM1-1)*N] := SubC(Z[(K-1)+(IM1-1)*N],MulC(Y,Z[(K-1)+(I-1)*N]));
_24:
     end;
_25:
   end;
  A[(JP1+0)+(J-1)*N] := Cmplx(0.0,0.0);
_26:
 end;
_27:
end;

end.
