Unit AGT3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAG10_p, AA03C_p;

procedure AGT3C(var A :Array of Complex; var B :Array of Complex;
                var ALFA :Array of Complex;
                var BETA :Array of Complex; N :Integer;
                var IERR :Integer);

implementation

procedure AGT3C(var A :Array of Complex; var B :Array of Complex;
                var ALFA :Array of Complex;
                var BETA :Array of Complex; N :Integer;
                var IERR :Integer);
var
NN,I,J,ITS,NM1,LB,L,NL,MB,M,NP1,LOR1,NNORN,K :Integer;
EPSA,EPSB,SS,R,ANORM,BNORM,ANI,BNI,C,D0,D1,D2,E0,E1 :Real;
S,W,Y,Z,ANNM1,DEN,NUM,ANM1M1,Y1 :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32;
begin
NN := N;
IERR := 0;
ANORM := 0.0;
BNORM := 0.0;
for I:=1 to NN do
 begin
  ANI := 0.0;
  if ( I = 1 ) 
   then goto _1;
  Y := A[(I-1)+(I-2)*N];
  ANI := ANI+Abs(Creal(Y))+Abs(Aimag(Y));
_1:
  BNI := 0.0;
  for J:=I to NN do
   begin
    ANI := ANI+Abs(Creal(A[(I-1)+(J-1)*N]))+Abs(Aimag(A[(I-1)+(J-1)*N]));
    BNI := BNI+Abs(Creal(B[(I-1)+(J-1)*N]))+Abs(Aimag(B[(I-1)+(J-1)*N]));
_2:
   end;
  if ( ANI > ANORM ) 
   then ANORM := ANI;
  if ( BNI > BNORM ) 
   then BNORM := BNI;
_3:
 end;
if ( ANORM = 0.0 ) 
 then ANORM := 1.0;
if ( BNORM = 0.0 ) 
 then BNORM := 1.0;
EPSB := BNORM;
EPSA := ANORM;
_4:
EPSA := EPSA/2.0;
EPSB := EPSB/2.0;
C := ANORM+EPSA;
if ( C > ANORM ) 
 then goto _4;
if ( NN <= 1 ) 
 then goto _30;
_5:
ITS := 0;
NM1 := NN-1;
_6:
D2 := Abs(Creal(A[(NN-1)+(NN-1)*N]))+Abs(Aimag(A[(NN-1)+(NN-1)*N]));
for LB:=2 to NN do
 begin
  L := NN+2-LB;
  SS := D2;
  Y := A[(L-2)+(L-2)*N];
  D2 := Abs(Creal(Y))+Abs(Aimag(Y));
  SS := SS+D2;
  Y := A[(L-1)+(L-2)*N];
  R := SS+Abs(Creal(Y))+Abs(Aimag(Y));
  if ( R = SS ) 
   then goto _8;
_7:
 end;
L := 1;
_8:
if ( L = NN ) 
 then goto _30;
if ( ITS < 30 ) 
 then goto _10;
if ( Abs(Creal(A[(NN-1)+(NM1-1)*N]))+Abs(Aimag(A[(NN-1)+(NM1-1)*N])) > 0.8*
     (Abs(Creal(ANNM1))+Abs(Aimag(ANNM1))) ) 
 then goto _9;
goto _11;
_9:
IERR := NN;
goto _31;
_10:
if ( ITS = 10 ) or ( ITS = 20 ) 
 then goto _13;
_11:
ANNM1 := A[(NN-1)+(NM1-1)*N];
ANM1M1 := A[(NM1-1)+(NM1-1)*N];
S := SubC(MulC(A[(NN-1)+(NN-1)*N],B[(NM1-1)+(NM1-1)*N]),MulC((ANNM1),B[(NM1-1)+(NN-1)*N]));
W := MulC(MulC(ANNM1,B[(NN-1)+(NN-1)*N]),SubC(MulC(A[(NM1-1)+(NN-1)*N],B[(NM1-1)+(NM1-1)*N]),MulC(B[(NM1-1)+(NN-1)*N],
        ANM1M1)));
Y := DivC((SubC(MulC(ANM1M1,B[(NN-1)+(NN-1)*N]),S)),Cmplx(2.0,0.0));
Y1 := AddC(MulC(Y,Y),W);
Z := AA03C(Y1);
if ( Abs(Creal(Z)) = 0.0 ) and ( Abs(Aimag(Z)) = 0.0 )
 then goto _12;
D0 := Creal(DivC(Y,Z));
if ( D0 < 0.0 ) 
 then Z := SubC(Cmplx(0.0,0.0),Z);
_12:
DEN := MulC(MulC((AddC(Y,Z)),B[(NM1-1)+(NM1-1)*N]),B[(NN-1)+(NN-1)*N]);
if ( Abs(Creal(DEN))+Abs(Aimag(DEN)) = 0.0 )
 then DEN := Cmplx(EPSA,0.0);
NUM := SubC(MulC((AddC(Y,Z)),S),W);
goto _14;
_13:
Y := A[(NM1-1)+(N-3)*N];
NUM := Cmplx(Abs(Creal(ANNM1))+Abs(Aimag(ANNM1)),
    Abs(Creal(Y))+Abs(Aimag(Y)));
DEN := Cmplx(1.0,0.0);
_14:
if ( NN = L+1 ) 
 then goto _16;
D2 := Abs(Creal(A[(NM1-1)+(NM1-1)*N]))+Abs(Aimag(A[(NM1-1)+(NM1-1)*N]));
E1 := Abs(Creal(ANNM1))+Abs(Aimag(ANNM1));
D1 := Abs(Creal(A[(NN-1)+(NN-1)*N]))+Abs(Aimag(A[(NN-1)+(NN-1)*N]));
NL := NN-(L+1);
for MB:=1 to NL do
 begin
  M := NN-MB;
  E0 := E1;
  Y := A[(M-1)+(M-2)*N];
  E1 := Abs(Creal(Y))+Abs(Aimag(Y));
  D0 := D1;
  D1 := D2;
  Y := A[(M-2)+(M-2)*N];
  D2 := Abs(Creal(Y))+Abs(Aimag(Y));
  Y := SubC(MulC(A[(M-1)+(M-1)*N],DEN),MulC(B[(M-1)+(M-1)*N],NUM));
  D0 := (D0+D1+D2)*(Abs(Creal(Y))+Abs(Aimag(Y)));
  E0 := E0*E1*(Abs(Creal(DEN))+Abs(Aimag(DEN)))+D0;
  if ( E0 = D0 ) 
   then goto _17;
_15:
 end;
_16:
M := L;
_17:
ITS := ITS+1;
W := SubC(MulC(A[(M-1)+(M-1)*N],DEN),MulC(B[(M-1)+(M-1)*N],NUM));
Z := MulC(A[(M+0)+(M-1)*N],DEN);
D1 := Abs(Creal(Z))+Abs(Aimag(Z));
D2 := Abs(Creal(W))+Abs(Aimag(W));
NP1 := NN+1;
LOR1 := L;
NNORN := NN;
for I:=M to NM1 do
 begin
  J := I+1;
  if ( I = M ) 
   then goto _18;
  W := A[(I-1)+(I-2)*N];
  Z := A[(J-1)+(I-2)*N];
  D1 := Abs(Creal(Z))+Abs(Aimag(Z));
  D2 := Abs(Creal(W))+Abs(Aimag(W));
  if ( D1 = 0.0 ) 
   then goto _6;
_18:
  if ( D2 > D1 ) 
   then goto _20;
  for K:=I to NNORN do
   begin
    Y := A[(I-1)+(K-1)*N];
    A[(I-1)+(K-1)*N] := A[(J-1)+(K-1)*N];
    A[(J-1)+(K-1)*N] := Y;
    Y := B[(I-1)+(K-1)*N];
    B[(I-1)+(K-1)*N] := B[(J-1)+(K-1)*N];
    B[(J-1)+(K-1)*N] := Y;
_19:
   end;
  if ( I > M ) 
   then A[(I-1)+(I-2)*N] := A[(J-1)+(I-2)*N];
  if ( D2 = 0.0 ) 
   then goto _23;
  Y := DivC(Cmplx(Creal(W)/D1,Aimag(W)/D1),Cmplx(Creal(Z)/D1,
    Aimag(Z)/D1));
  goto _21;
_20:
  Y := DivC(Cmplx(Creal(Z)/D2,Aimag(Z)/D2),Cmplx(Creal(W)/D2,
    Aimag(W)/D2));
_21:
  for K:=I to NNORN do
   begin
    A[(J-1)+(K-1)*N] := SubC(A[(J-1)+(K-1)*N],MulC(Y,A[(I-1)+(K-1)*N]));
    B[(J-1)+(K-1)*N] := SubC(B[(J-1)+(K-1)*N],MulC(Y,B[(I-1)+(K-1)*N]));
_22:
   end;
  if ( I > M ) 
   then A[(J-1)+(I-2)*N] := Cmplx(0.0,0.0);
_23:
  Z := B[(J-1)+(I-1)*N];
  W := B[(J-1)+(J-1)*N];
  D2 := Abs(Creal(W))+Abs(Aimag(W));
  D1 := Abs(Creal(Z))+Abs(Aimag(Z));
  if ( D1 = 0.0 ) 
   then goto _6;
  if ( D2 > D1 ) 
   then goto _26;
  for K:=LOR1 to J do
   begin
    Y := A[(K-1)+(J-1)*N];
    A[(K-1)+(J-1)*N] := A[(K-1)+(I-1)*N];
    A[(K-1)+(I-1)*N] := Y;
    Y := B[(K-1)+(J-1)*N];
    B[(K-1)+(J-1)*N] := B[(K-1)+(I-1)*N];
    B[(K-1)+(I-1)*N] := Y;
_24:
   end;
  if ( I = NM1 ) 
   then goto _25;
  Y := A[(J+0)+(J-1)*N];
  A[(J+0)+(J-1)*N] := A[(J+0)+(I-1)*N];
  A[(J+0)+(I-1)*N] := Y;
_25:
  if ( D2 = 0.0 ) 
   then goto _29;
  Z := DivC(Cmplx(Creal(W)/D1,Aimag(W)/D1),Cmplx(Creal(Z)/D1,
    Aimag(Z)/D1));
  goto _27;
_26:
  Z := DivC(Cmplx(Creal(Z)/D2,Aimag(Z)/D2),Cmplx(Creal(W)/D2,
    Aimag(W)/D2));
_27:
  for K:=LOR1 to J do
   begin
    A[(K-1)+(I-1)*N] := SubC(A[(K-1)+(I-1)*N],MulC(Z,A[(K-1)+(J-1)*N]));
    B[(K-1)+(I-1)*N] := SubC(B[(K-1)+(I-1)*N],MulC(Z,B[(K-1)+(J-1)*N]));
_28:
   end;
  B[(J-1)+(I-1)*N] := Cmplx(0.0,0.0);
  if ( I < NM1 ) 
   then A[(I+1)+(I-1)*N] := SubC(A[(I+1)+(I-1)*N],MulC(Z,A[(I+1)+(J-1)*N]));
_29:
 end;
goto _6;
_30:
ALFA[NN-1] := A[(NN-1)+(NN-1)*N];
BETA[NN-1] := B[(NN-1)+(NN-1)*N];
if ( NN = 1 ) 
 then goto _32;
NN := NM1;
if ( NN > 1 ) 
 then goto _5;
goto _30;
_31:
UTAG10(IERR,44);
_32:
end;

end.
